Difference between revisions of "Arch Rebar"

From FreeCAD Documentation
Jump to: navigation, search
(Marked this version for translation)
 
(38 intermediate revisions by 4 users not shown)
Line 1: Line 1:
 +
<languages/>
 
<translate>
 
<translate>
 
<!--T:1-->
 
<!--T:1-->
{{GuiCommand|Name=Arch_Rebar|Workbenches=[[Arch Module|Arch]]|MenuLocation=Arch -> Rebar|Shortcut=R B|SeeAlso=[[Arch Structure]]}}
+
{{docnav|[[Arch_Rebar_BeamReinforcement|BeamReinforcement]]|[[Arch_Floor|Floor]]|[[Arch_Module|Arch]]|IconL=Arch_Rebar_BeamReinforcement.svg |IconC=Workbench_Arch.svg |IconR=Arch_Floor.svg}}
 +
 
 +
<!--T:23-->
 +
{{GuiCommand
 +
|Name=Arch Rebar
 +
|MenuLocation=Arch → Rebar
 +
|Workbenches=[[Arch Module|Arch]]
 +
|Shortcut=R B
 +
|SeeAlso=[[Arch Structure|Arch Structure]], [[Reinforcement Addon|Reinforcement Addon]]
 +
}}
  
 
==Description== <!--T:2-->
 
==Description== <!--T:2-->
  
 
<!--T:3-->
 
<!--T:3-->
The Rebar tool allows you to place [http://en.wikipedia.org/wiki/Rebar reinforcing bars] inside [[Arch Structure]] objects. Rebar objects are based on 2D profiles such as [[Sketcher Module|sketches]] or [[Draft Module|draft objects]], that must be drawn on a face of a structure object. You can then adjust the configuration of the rebars, such as the number and diameter of the bars, or the offset distance between the two ends of the structural element.
+
The [[Arch Rebar|Arch Rebar]] tool allows you to place [http://en.wikipedia.org/wiki/Rebar reinforcing bars] inside [[Arch Structure|Arch Structure]] objects.
  
<!--T:4-->
+
<!--T:20-->
 +
Rebar objects are based on 2D profiles such as [[Draft Workbench|Draft objects]] and [[Sketcher Workbench|Sketches]], that must be drawn on a face of the structural object. After creation you can adjust the properties of the rebar, including the number and diameter of the bars, and the offset distance between them and the faces of the structural element.
 +
 
 +
</translate>
 
[[Image:Arch Rebar example.jpg|400px]]
 
[[Image:Arch Rebar example.jpg|400px]]
 +
<translate>
 +
<!--T:5-->
 +
{{Caption|Structural object with two sketches drawn on its faces, which are then turned into two sets of rebar objects}}
 +
 +
== Extension available == <!--T:16-->
  
<!--T:5-->
+
<!--T:17-->
The above image shows a structural object, where two sketches are drawn, defining two bar diagrams. These two sketches are then turned into rebar objects.
+
The Rebar tool is enhanced by the [[Reinforcement Addon|Reinforcement Addon]], which is installed by the [[Addon Manager|Addon Manager]]. The additional rebar types available with the addon are:
 +
* [[Image:Arch_Rebar_Straight.svg|32px]] [[Arch_Rebar_Straight|Straight Rebar]]
 +
* [[Image:Arch_Rebar_UShape.svg|32px]] [[Arch_Rebar_UShape|UShape Rebar]]
 +
* [[Image:Arch_Rebar_LShape.svg|32px]] [[Arch_Rebar_LShape|LShape Rebar]]
 +
* [[Image:Arch_Rebar_BentShape.svg|32px]] [[Arch_Rebar_BentShape|Bent Shape Rebar]]
 +
* [[Image:Arch_Rebar_Stirrup.svg|32px]] [[Arch_Rebar_Stirrup|Stirrup Rebar]]
 +
* [[Image:Arch_Rebar_Helical.svg|32px]] [[Arch_Rebar_Helical|Helical Rebar]]
  
 
==How to use== <!--T:6-->
 
==How to use== <!--T:6-->
  
 
<!--T:7-->
 
<!--T:7-->
# Create a [[Arch Structure|structure]] element
+
# Create an {{Button|[[Image:Arch_Structure.svg|16px]] [[Arch Structure|Arch Structure]]}} element.
# Switch to the [[Sketcher Workbench]]
+
# Switch to the [[Sketcher Workbench|Sketcher Workbench]].
# Select one face of the structural element
+
# Select one face of the structural element.
# Press the {{KEY|[[Image:Sketcher NewSketch.png|16px]] [[Sketcher NewSketch|New Sketch]]}} button to start a new sketch on the selected face
+
# Press the {{Button|[[Image:Sketcher NewSketch.svg|16px]] [[Sketcher NewSketch|New Sketch]]}} button to start a new sketch on the selected face.
# Draw the diagram of your bar
+
# Draw the diagram of your bar.
# Press the {{KEY|[[Image:Sketcher LeaveSketch.png|16px]] [[Sketcher LeaveSketch|Leave Sketch]]}} button to finish
+
# Press the {{Button|[[Image:Sketcher LeaveSketch.svg|16px]] [[Sketcher LeaveSketch|Leave Sketch]]}} button to finish.
# Switch back to the [[Arch Workbench]]
+
# Switch back to the [[Arch Workbench]].
# Select the sketch you just drew
+
# Select the sketch you just drew.
# Press the {{KEY|[[Image:Arch Rebar.png|16px]] [[Arch Rebar]]}} button, or press {{KEY|R}} then {{KEY|B}} keys
+
# Press the {{Button|[[Image:Arch Rebar.svg|16px]] [[Arch Rebar|Arch Rebar]]}} button, or press {{KEY|R}} then {{KEY|B}} keys.
# Adjust the desired properties (your rebar might not appear immediately, if some of the properties create an impossible situation, such as the bar diameter being 0, or the offset distances being bigger than the length of the structural element)
+
# Adjust the desired properties (your rebar might not appear immediately, if some of the properties create an impossible situation, such as the bar diameter being 0, or the offset distances being bigger than the length of the structural element).
 +
 
 +
<!--T:24-->
 +
Although normally a rebar is used inside an Arch Structure, since FreeCAD 0.19 the rebar can be created outside of any host object. To host a rebar inside an object, you just need to set its {{PropertyData|Host}}.
  
 
==Options== <!--T:8-->
 
==Options== <!--T:8-->
  
 
<!--T:9-->
 
<!--T:9-->
 +
* Rebars share the common properties and behaviours of all [[Arch Component|Arch Components]]
 
* The rounding value is expressed in times the diameter. If your bar has a diameter of 5mm, a rounding value of 3 will create rounding at angles with a radius of 15mm.
 
* The rounding value is expressed in times the diameter. If your bar has a diameter of 5mm, a rounding value of 3 will create rounding at angles with a radius of 15mm.
 
* Default values for new rebars can be set in the Arch preferences settings.
 
* Default values for new rebars can be set in the Arch preferences settings.
Line 48: Line 76:
  
 
==Scripting== <!--T:12-->
 
==Scripting== <!--T:12-->
 +
{{Emphasis|See also:}} [[Arch API|Arch API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].
  
 
<!--T:13-->
 
<!--T:13-->
The Rebar tool can by used in [[macros]] and from the python console by using the following function:
+
The Rebar tool can be used in [[macros|macros]] and from the [[Python|Python]] console by using the following function:
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
makeRebar (structure,sketch,[diameter],[amount],[offset])
+
Rebar = makeRebar(baseobj=None, sketch=None, diameter=None, amount=1, offset=None, name="Rebar")
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
 
<!--T:14-->
 
<!--T:14-->
* Adds a Reinforcing Bar object to the given structural object, using the given sketch as profile.
+
* Creates a {{incode|Rebar}} object from the given {{incode|baseobj}}, which is an [[Arch Structure|Arch Structure]], and a {{incode|sketch}} as profile.
* If no diameter, amount or offset value is given, the default values from the Arch preferences settings are applied.
+
** {{incode|diameter}}, {{incode|amount}}, and {{incode|offset}} are used to define the characteristics of the bars.
* Returns the new Rebar object.
+
** If no {{incode|diameter}}, {{incode|amount}}, or {{incode|offset}} values are given, the default values from the [[Arch Preferences|Arch Preferences]] are used.
  
 
<!--T:15-->
 
<!--T:15-->
 
Example:
 
Example:
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
import FreeCAD, Arch, Sketcher, PArt
+
import FreeCAD, Arch, Part
struct = Arch.makeStructure(1,1,3)
+
 
sketch = FreeCAD.ActiveDocument.addObject('Sketcher::SketchObject','Sketch')
+
Structure = Arch.makeStructure(None, length=1000, width=1000, height=3000)
sketch.Support = (struct,["Face6"])
+
Structure.ViewObject.Transparency = 80
sketch.addGeometry(Part.Line(App.Vector(-0.4,0.4,0),App.Vector(0.4,0.4,0)))
+
FreeCAD.ActiveDocument.recompute()
Arch.makeRebar(structure,sketch)
 
</syntaxhighlight>
 
  
<languages/>
+
p1 = FreeCAD.Vector(-400, 400, 0)
 +
p2 = FreeCAD.Vector(400, 400, 0)
 +
Sketch = FreeCAD.ActiveDocument.addObject('Sketcher::SketchObject', 'Sketch')
 +
Sketch.MapMode = "FlatFace"
 +
Sketch.Support = [(Structure, "Face6")]
 +
Sketch.addGeometry(Part.LineSegment(p1, p2))
 +
FreeCAD.ActiveDocument.recompute()
 +
 
 +
Rebar = Arch.makeRebar(Structure, Sketch, diameter=80, amount=7, offset=50)
 +
Rebar.OffsetStart = 100
 +
Rebar.OffsetEnd = 100
 +
FreeCAD.ActiveDocument.recompute()
 +
}}
 +
<translate>
 +
<!--T:19-->
 +
{{docnav|[[Arch_Rebar_BeamReinforcement|BeamReinforcement]]|[[Arch_Floor|Floor]]|[[Arch_Module|Arch]]|IconL=Arch_Rebar_BeamReinforcement.svg |IconC=Workbench_Arch.svg |IconR=Arch_Floor.svg}}
 +
 
 +
<!--T:21-->
 +
{{Arch Tools navi}}
 +
 
 +
<!--T:22-->
 +
{{Userdocnavi}}
 +
 
 +
 
 +
</translate>

Latest revision as of 20:37, 20 August 2019

Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎italiano • ‎日本語 • ‎română • ‎русский • ‎svenska • ‎українська
Arrow-left.svg Previous: Arch Rebar BeamReinforcement.svg BeamReinforcement
Next: Floor Arch Floor.svg Arrow-right.svg

Arch Rebar.svg Arch Rebar

Menu location
Arch → Rebar
Workbenches
Arch
Default shortcut
R B
Introduced in version
-
See also
Arch Structure, Reinforcement Addon


Description

The Arch Rebar tool allows you to place reinforcing bars inside Arch Structure objects.

Rebar objects are based on 2D profiles such as Draft objects and Sketches, that must be drawn on a face of the structural object. After creation you can adjust the properties of the rebar, including the number and diameter of the bars, and the offset distance between them and the faces of the structural element.

Arch Rebar example.jpg

Structural object with two sketches drawn on its faces, which are then turned into two sets of rebar objects


Extension available

The Rebar tool is enhanced by the Reinforcement Addon, which is installed by the Addon Manager. The additional rebar types available with the addon are:

How to use

  1. Create an Arch Structure.svg Arch Structure element.
  2. Switch to the Sketcher Workbench.
  3. Select one face of the structural element.
  4. Press the Sketcher NewSketch.svg New Sketch button to start a new sketch on the selected face.
  5. Draw the diagram of your bar.
  6. Press the Sketcher LeaveSketch.svg Leave Sketch button to finish.
  7. Switch back to the Arch Workbench.
  8. Select the sketch you just drew.
  9. Press the Arch Rebar.svg Arch Rebar button, or press R then B keys.
  10. Adjust the desired properties (your rebar might not appear immediately, if some of the properties create an impossible situation, such as the bar diameter being 0, or the offset distances being bigger than the length of the structural element).

Although normally a rebar is used inside an Arch Structure, since FreeCAD 0.19 the rebar can be created outside of any host object. To host a rebar inside an object, you just need to set its DATAHost.

Options

  • Rebars share the common properties and behaviours of all Arch Components
  • The rounding value is expressed in times the diameter. If your bar has a diameter of 5mm, a rounding value of 3 will create rounding at angles with a radius of 15mm.
  • Default values for new rebars can be set in the Arch preferences settings.
  • If a direction vector is not specified, the direction and distance along which the bars will spread is calculated automatically from the host structural object, by taking the normal direction of the base sketch, and taking its intersection with the structural object. If you specify a direction vector, the length of that vector will also be taken into account.
  • The spacing value is calculated from the current amount of bars, and represents the distance between the axes of each bar. You must therefore subtract the bar diameter to obtain the size of the free space between bars.

Properties

  • DATAAmount: The amount of bars.
  • DATADiameter: The diameter of the bars.
  • DATADirection: The direction (and length) along which the bars must spread. If the value is (0,0,0), the direction is calculated automatically from the host structural object.
  • DATAOffset Start: The offset distance between the border of the structural object and the first bar.
  • DATAOffset End: The offset distance between the border of the structural object and the last bar.
  • DATARounding: A rounding value to be applied to the corners of the bars, expressed in times the diameter.
  • DATASpacing: The distance between the axes of each bar.

Scripting

See also: Arch API and FreeCAD Scripting Basics.

The Rebar tool can be used in macros and from the Python console by using the following function:

Rebar = makeRebar(baseobj=None, sketch=None, diameter=None, amount=1, offset=None, name="Rebar")
  • Creates a Rebar object from the given baseobj, which is an Arch Structure, and a sketch as profile.
    • diameter, amount, and offset are used to define the characteristics of the bars.
    • If no diameter, amount, or offset values are given, the default values from the Arch Preferences are used.

Example:

import FreeCAD, Arch, Part

Structure = Arch.makeStructure(None, length=1000, width=1000, height=3000)
Structure.ViewObject.Transparency = 80
FreeCAD.ActiveDocument.recompute()

p1 = FreeCAD.Vector(-400, 400, 0)
p2 = FreeCAD.Vector(400, 400, 0)
Sketch = FreeCAD.ActiveDocument.addObject('Sketcher::SketchObject', 'Sketch')
Sketch.MapMode = "FlatFace"
Sketch.Support = [(Structure, "Face6")]
Sketch.addGeometry(Part.LineSegment(p1, p2))
FreeCAD.ActiveDocument.recompute()

Rebar = Arch.makeRebar(Structure, Sketch, diameter=80, amount=7, offset=50)
Rebar.OffsetStart = 100
Rebar.OffsetEnd = 100
FreeCAD.ActiveDocument.recompute()
Arrow-left.svg Previous: Arch Rebar BeamReinforcement.svg BeamReinforcement
Next: Floor Arch Floor.svg Arrow-right.svg